#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <windows.h>
#include <time.h>
#include <conio.h>
#include "../include/paz_browser.h"

int isClassExclusive(char* fileName,FileBlock* fileBlocks,MetaFileInfo* metaFileInfo)
{
    int i = 0;
    char* fileNameNoClass = removeClassPrefix(fileName);
    //printf("\n%s", fileNameNoClass);
    for (i = 0; i < metaFileInfo->fileBlocksCount; i++)
    {
        if (strcmpi(fileBlocks[i].fileName,fileName) != 0 && strstr(fileBlocks[i].fileName,fileNameNoClass))
        {
            return 0;
        }
    }

    return 1;
}

/*int isClassExclusive(char* fileName,FileBlock* fileBlocks,MetaFileInfo* metaFileInfo)
{
    int i = 0;
    char* twoDigits = getTwoDigits(fileName);
    char* fourDigits = getFourDigits(fileName);
    char* middleDigits = getMiddleDigits(fileName);
    for (i = 0; i < metaFileInfo->fileBlocksCount; i++)
    {


        if ((strcmp(fileName,fileBlocks[i].fileName) != 0) && (strcmp(twoDigits,getTwoDigits(fileBlocks[i].fileName)) == 0) && (strcmp(middleDigits,getMiddleDigits(fileBlocks[i].fileName)) == 0) && (strcmp(fourDigits,getFourDigits(fileBlocks[i].fileName)) == 0))
        {

                printf("\n\nNot exclusive: %s - %s : diff name:%d %s==%s %s==%s  %s==%s\n\n",fileName,fileBlocks[i].fileName,(strcmp(fileName,fileBlocks[i].fileName) != 0),twoDigits,getTwoDigits(fileBlocks[i].fileName),middleDigits,getMiddleDigits(fileBlocks[i].fileName),fourDigits,getFourDigits(fileBlocks[i].fileName));
               // PAUSE();

            return 0;
        }
    }
    printf("\n%s is exclusive",fileName );
    PAUSE();
    return 1;
}*/

int main()
{
    srand(time(NULL));
    int option  = 0;
    int i = 0;
    int j = 0;
    int k = 0;
    printf("\n1 - Highest numbers Armors");
    printf("\n2 - Class-Exclusive Armors");
    printf("\n3 - Random Armors");
    printf("\nR: ");
    scanf("%d", &option);

    printf("\nOPENED META FILE:");
    MetaFileInfo* metaFileInfo = getMetaFileInfo(getLatestBackup());
    FileBlock* fileBlocks = fillFileBlocks(metaFileInfo,getLatestBackup(),1);

    FileBlock* cashShopArmor = (FileBlock*) calloc(metaFileInfo->fileBlocksCount , sizeof(FileBlock));
    FileBlock* regularArmors = (FileBlock*) calloc(metaFileInfo->fileBlocksCount , sizeof(FileBlock));
    FileBlock* classExclusiveArmors = (FileBlock*) calloc(metaFileInfo->fileBlocksCount , sizeof(FileBlock));

    int cashShopCount = 0;
    int regularCount = 0;
    int classExclusiveCount = 0;
    printf("\nSeparating armors");
    for (i = 0; i < metaFileInfo->fileBlocksCount; i++)
    {
        if (strstr(fileBlocks[i].folderName,"character/model/1_pc/") && strstr(fileBlocks[i].folderName,"9_upperbody")
            && !strstr(fileBlocks[i].fileName,"_dm")
            && !strstr(fileBlocks[i].fileName,"0034")
            && !strstr(fileBlocks[i].fileName,"_s")
            && !strstr(fileBlocks[i].fileName,"_01.pac")
            && !strstr(fileBlocks[i].fileName,"_mul")
            && !strstr(fileBlocks[i].fileName,"_10_ub_0004")
            && !strstr(fileBlocks[i].fileName,"_00_ub_0039_o")
            && !strstr(fileBlocks[i].fileName,"phw_00_ub_0063")
            && !strstr(fileBlocks[i].fileName,"phw_00_ub_0049")
            && !strstr(fileBlocks[i].fileName,"phw_00_ub_0005")
            && !strstr(fileBlocks[i].fileName,"phw_00_ub_0003")
            && !strstr(fileBlocks[i].fileName,"pew_03_ub_0001")
            && !strstr(fileBlocks[i].fileName,"pew_03_ub_0003")
            && !strstr(fileBlocks[i].fileName,"pcm")
            && !(fileBlocks[i].hasRealName && strstr(fileBlocks[i].RealName,"Costume"))
            && (getTwoDigits(fileBlocks[i].fileName)[1] != 'w')
            && (getTwoDigits(fileBlocks[i].fileName)[1] != 'm')
        )
        {
            if (isRegular(fileBlocks[i].fileName))
            {
                memcpy(&regularArmors[regularCount],&fileBlocks[i],sizeof(FileBlock));
                regularCount++;
            }
            if (option == 2 && isClassExclusive(fileBlocks[i].fileName,fileBlocks,metaFileInfo) && strcmp(getTwoDigits(fileBlocks[i].fileName),"00") == 0)
            {
                memcpy(&classExclusiveArmors[classExclusiveCount],&fileBlocks[i],sizeof(FileBlock));
                classExclusiveCount++;
            }
            else if (strcmp(getTwoDigits(fileBlocks[i].fileName),"00") == 0)
            {
                memcpy(&cashShopArmor[cashShopCount],&fileBlocks[i],sizeof(FileBlock));
                cashShopCount++;
            }
         }
    }
    printf("\nregularCount: %d", regularCount);
     printf("\ncashShopCount: %d", cashShopCount);
      printf("\nClass-Exclusive count: %d", classExclusiveCount);

    printf("\n\nSorting cash shop armors...");
    qsort(cashShopArmor,cashShopCount,sizeof(FileBlock),sort_by_file_name_simple_pointer_desc);
    printf("\nDone\n");

    printf("\nReading Real Armor Names file...");
    readRealNamesFile(regularArmors, regularCount);
    printf("\nDone\n");
    /*for(i = 0; i < regularCount; i++)
    {
        if (regularArmors[i].hasRealName)
        {
            printf("\n%s",regularArmors[i].RealName);
        }
        else
        {
            printf("\n%s",regularArmors[i].fileName);
        }

    }*/
    printf("\n\nSorting regular armors...");
    qsort(regularArmors,regularCount,sizeof(FileBlock),sort_by_file_regular_name);
    if (option == 2)
    {
        qsort(classExclusiveArmors,classExclusiveCount,sizeof(FileBlock),sort_by_file_name_simple_pointer_desc);
    }

    printf("\nDone.\n");


    for (j = 0; j < cashShopCount; j++)
    {
       // printf("\n%s",cashShopArmor[j].fileName);
    }

  // printf("\n\nClass-Exclusive Armors:");
    for (k = 0; k < classExclusiveCount; k++)
    {
       // printf("\n%s",classExclusiveArmors[k].fileName);
    }


    FILE* fp = fopen("patcher_resources\\armors_to_swap.txt","wb");
    char* arrow = "->";
    char newLine[2];
    newLine[0] = 13;
    newLine[1] = 10;
    int armorSwapped = 0;
         int exclusivesUsed = 0;
        int cashShopUsed = 0;
        int randomUsed = 0;
    printf("\n\nWriting to file...\n");
    j = 0;
    for(i = 0; i < regularCount; i++)
    {
        armorSwapped = 0;
        fwrite(newLine,2,1,fp);
        printf("\n%s",regularArmors[i].fileName);

        fwrite(regularArmors[i].fileName,strlen(regularArmors[i].fileName),1,fp);
        printf("->");
        fwrite(arrow,strlen(arrow),1,fp);

        if (option != 3)
        {
            char swap[256] = "";
            if (strstr(regularArmors[i].fileName,"pww_03_ub_0003"))
            {
                strcpy(swap,"pww_00_ub_0034.pac");
            }

            if (strstr(regularArmors[i].fileName,"pwm_03_ub_0003"))
            {
                strcpy(swap,"pwm_00_ub_0001.pac");
            }

            if (strstr(regularArmors[i].fileName,"phw_02_ub_0001"))
            {
                strcpy(swap,"phw_02_ub_0006.pac");
            }
             if (strstr(regularArmors[i].fileName,"pew_02_ub_0001"))
            {
                strcpy(swap,"pew_00_ub_0010.pac");
            }

             if (strstr(regularArmors[i].fileName,"pvw_02_ub_0007"))
            {
                strcpy(swap,"pvw_00_ub_0002.pac");
            }

             if (strstr(regularArmors[i].fileName,"pbw_02_ub_0001"))
            {
                strcpy(swap,"PBW_00_UB_0017.pac");
            }

             if (strstr(regularArmors[i].fileName,"phm_02_ub_0001"))
            {
                strcpy(swap,"PHM_00_UB_0060.pac");
            }

             if (strstr(regularArmors[i].fileName,"pgm_02_ub_0001"))
            {
                strcpy(swap,"pgm_00_ub_0044.pac");
            }

              if (strstr(regularArmors[i].fileName,"pkww_02_ub_0001"))
            {
                strcpy(swap,"pkww_00_ub_0001.pac");
            }


            if (strstr(regularArmors[i].fileName,"pkm_02_ub_0001"))
            {
                strcpy(swap,"pkm_00_ub_0001.pac");
            }

              if (strstr(regularArmors[i].fileName,"pnm_02_ub_0001"))
            {
                strcpy(swap,"pnm_00_ub_0001.pac");
            }

              if (strstr(regularArmors[i].fileName,"pnw_02_ub_0001"))
            {
                strcpy(swap,"PNW_00_UB_0001.pac");
            }

            if (strstr(regularArmors[i].fileName,"pdw_02_ub_0001"))
            {
                strcpy(swap,"pdw_00_ub_0001.pac");
            }

            if (strstr(regularArmors[i].fileName,"pcm_02_ub_0001"))
            {
                strcpy(swap,"pcm_00_ub_0001.pac");
            }

            if (strlen(swap) >= 18)
            {
                fwrite(swap,strlen(swap),1,fp);
            printf("%s",swap);

            continue;
            }

        }


        if (option == 3)
        {
            do
            {
                j = rand() % (cashShopCount);

            }while(cashShopArmor[j].isPatched || (strcmpi(getClassPrefix(cashShopArmor[j].fileName),getClassPrefix(regularArmors[i].fileName)) != 0));
            fwrite(cashShopArmor[j].fileName,strlen(cashShopArmor[j].fileName),1,fp);
            printf("%s",cashShopArmor[j].fileName);

            cashShopArmor[j].isPatched = 1;
        }

        if (option == 2)
        {
            if ( i < (regularCount - classExclusiveCount))
            {
                do
                {
                    j = rand() % (cashShopCount);

                }while(cashShopArmor[j].isPatched || (strcmpi(getClassPrefix(cashShopArmor[j].fileName),getClassPrefix(regularArmors[i].fileName)) != 0));
                fwrite(cashShopArmor[j].fileName,strlen(cashShopArmor[j].fileName),1,fp);
                printf("%s(R)",cashShopArmor[j].fileName);
                randomUsed++;
                cashShopArmor[j].isPatched = 1;
            }
            else
            {
                for (k = 0; k < classExclusiveCount; k++)
                {
                    //printf("\n%d/%d - %s",k, classExclusiveCount,classExclusiveArmors[k].fileName);
                    if (strcmp(getClassPrefix(classExclusiveArmors[k].fileName),getClassPrefix(regularArmors[i].fileName)) == 0)
                    {
                        if (classExclusiveArmors[k].isPatched == 0)
                        {
                            fwrite(classExclusiveArmors[k].fileName,strlen(classExclusiveArmors[k].fileName),1,fp);
                            printf("%s (E)",classExclusiveArmors[k].fileName);
                            exclusivesUsed++;

                            classExclusiveArmors[k].isPatched = 1;
                            armorSwapped = 1;
                            break;
                        }


                    }
                }
                if (armorSwapped == 0)
                {
                    do
                    {
                        j = rand() % (cashShopCount);

                    }while(cashShopArmor[j].isPatched || (strcmpi(getClassPrefix(cashShopArmor[j].fileName),getClassPrefix(regularArmors[i].fileName)) != 0));
                    fwrite(cashShopArmor[j].fileName,strlen(cashShopArmor[j].fileName),1,fp);
                    printf("%s(R)",cashShopArmor[j].fileName);

                    randomUsed++;
                    cashShopArmor[j].isPatched = 1;
                }
            }


        }
        if (option == 1)
        {

                for (j = 0; j < cashShopCount; j++)
                {
                    //printf("\n%d/%d - %s",j, cashShopCount,cashShopArmor[j].fileName);
                    if (strcmp(getClassPrefix(cashShopArmor[j].fileName),getClassPrefix(regularArmors[i].fileName)) == 0)
                    {
                        if (cashShopArmor[j].isPatched == 0)
                        {
                            fwrite(cashShopArmor[j].fileName,strlen(cashShopArmor[j].fileName),1,fp);
                            printf("%s (C)",cashShopArmor[j].fileName);
                            cashShopUsed++;
                            cashShopArmor[j].isPatched = 1;
                            armorSwapped = 1;
                            break;
                        }
                    }

            }
            if (!armorSwapped)
            {
               // printf("All used");
            }

        }

    }
    printf("\n\nExclusive used: %d/%d", exclusivesUsed, classExclusiveCount);
    printf("\nCash shop used: %d/%d", cashShopUsed, cashShopCount);
    printf("\nRandom used: %d", randomUsed);


    fclose(fp);

    PAUSE();
    return 0;
}
